#include "plugin.h"
#define textlength 2.0
BOOL TNT=FALSE;
BOOL PushButton=FALSE;
BOOL QuitButton=FALSE;
GLuint Mylist;
struct _WhereIs3DTop * WhereIs3DTop;
BOOL Started=FALSE;
int MyUnique;
struct Icon3D * Object;
struct _LookAngle * LookAngle;
GLdouble * Viewer;

GLuint Getn(GLuint n);
void CreateTextList(GLuint i, char * dynbitmap, SIZE lsize, SIZE csize);
void MakeTextBox(GLuint i);
void MakeCube (GLuint i, GLfloat cubesize, GLfloat * FrontColor);
void MakePhantomCube (GLuint i, GLfloat cubesize, GLfloat * FrontColor);

#ifdef PLUGIN_EXPORTS //VS
BOOL APIENTRY StartPlugin   (struct _WhereIs3DTop * brr);
void APIENTRY StopPlugin   (int Unique);
void APIENTRY TimerDraw   (int Unique);
void APIENTRY PhantomDraw   (int Unique);
BOOL APIENTRY ReceiveMessage   (struct _PluginMessage * PluginMessage);
#else //Borland bcc55
BOOL _export APIENTRY StartPlugin   (struct _WhereIs3DTop * brr);
void _export APIENTRY StopPlugin   (int Unique);
void _export APIENTRY TimerDraw   (int Unique);
void _export APIENTRY PhantomDraw   (int Unique);
BOOL _export APIENTRY ReceiveMessage   (struct _PluginMessage * PluginMessage);
#endif

/**********************************************************************************************/

BOOL APIENTRY StartPlugin (struct _WhereIs3DTop * brr)
{GLfloat FrontColor[3] = {0.0,0.5,0.0};

if (Started)return FALSE;
WhereIs3DTop = brr;

Mylist = glGenLists(7);

MakeCube(Mylist,1.0,FrontColor);
MakePhantomCube(Mylist+1,1.0,FrontColor);

FrontColor[0]=0.0;
FrontColor[1]=0.0;
FrontColor[2]=0.5;
MakeCube(Mylist+2,0.2,NULL);				// no frontcolor defined in this button-list
FrontColor[0]=1.0;
FrontColor[1]=0.0;
FrontColor[2]=0.0;
MakePhantomCube(Mylist+3,0.2,FrontColor);

FrontColor[0]=0.7;
FrontColor[1]=0.0;
FrontColor[2]=0.0;
MakeCube(Mylist+4,0.2,FrontColor);
FrontColor[0]=0.0;
FrontColor[1]=0.0;
FrontColor[2]=1.0;
MakePhantomCube(Mylist+5,0.2,FrontColor);

MakeTextBox(Mylist+6);

MyUnique=WhereIs3DTop->Unique;
Object=WhereIs3DTop->Object;
Viewer=WhereIs3DTop->Viewer;
LookAngle=WhereIs3DTop->LookAngle;
TNT=WhereIs3DTop->TNT;
Started=TRUE;
return TRUE;
}

void APIENTRY StopPlugin (int Unique)
{
if (MyUnique!=Unique)return;
glDeleteLists(Mylist,7);
}

void APIENTRY TimerDraw (int Unique)
{
if (MyUnique!=Unique)return;
glCallList(Mylist);

glPushMatrix();
if (PushButton)glTranslatef(0.5,0.0,0.9);
else glTranslatef(0.5,0.0,1.2);
glColor3ubv(&Object->Scratch[80]);
glCallList(Mylist+2);
glPopMatrix();

glPushMatrix();
if (QuitButton)glTranslatef(-0.5,0.0,0.9);
else glTranslatef(-0.5,0.0,1.2);
glCallList(Mylist+4);
glPopMatrix();

glBindTexture(GL_TEXTURE_2D,0);					//no texture-object
glCallList(Mylist+6);

//LookAngle->x+=((GLfloat)random(100)-50.0)/100.0*M_PI/180.0;         //you can rock the view-angle also..
//LookAngle->y+=((GLfloat)random(100)-50.0)/100.0*M_PI/180.0;         //you can rock the view-angle also..
Viewer[0]+=((GLfloat)rand()/RAND_MAX-0.5)/10.0;
Viewer[1]+=((GLfloat)rand()/RAND_MAX-0.5)/10.0;
Viewer[2]+=((GLfloat)rand()/RAND_MAX-0.5)/10.0;
}

void APIENTRY PhantomDraw (int Unique)
{
glCallList(Mylist+1);

glPushMatrix();
if (PushButton)glTranslatef(0.5,0.0,0.9);
else glTranslatef(0.5,0.0,1.2);
glCallList(Mylist+3);
glPopMatrix();

glPushMatrix();
if (QuitButton)glTranslatef(-0.5,0.0,0.9);
else glTranslatef(-0.5,0.0,1.2);
glCallList(Mylist+5);
glPopMatrix();

}

BOOL APIENTRY ReceiveMessage (struct _PluginMessage * PluginMessage)
{
switch (PluginMessage->Message) {

	case WM_RELOCATE:
	Object=(struct Icon3D *)PluginMessage->lParam;
	break;

	case WM_LBUTTONDOWN:
	if (PluginMessage->Red > 127)
		{
		PostMessage(WhereIs3DTop->hWnd,WM_COMMAND,PLUGIN_COLOR,MyUnique);
		if (PushButton)PushButton=FALSE;
		else PushButton=TRUE;
		return TRUE;
		}
	if (PluginMessage->Blue > 127)
		{
		if (QuitButton)QuitButton=FALSE;
		else QuitButton=TRUE;
		return TRUE;
		}
	break;

	case WM_LBUTTONUP:
	if (QuitButton)PostMessage(WhereIs3DTop->hWnd,WM_EXT_STOP_PLUGIN,MyUnique,0);		//You can stop the plugin
																													//yourself also ofcourse
	break;

	case WM_MBUTTONDOWN:
	if (PluginMessage->Red > 127)
		{
		if (PushButton)PushButton=FALSE;
		else PushButton=TRUE;
		return TRUE;
		}
	break;

	case WM_MBUTTONUP:
	break;

	case WM_RBUTTONDOWN:
	if (PluginMessage->Red > 127)
		{
		if (PushButton)PushButton=FALSE;
		else PushButton=TRUE;
		return TRUE;
		}
	break;

	case WM_RBUTTONUP:
	break;

	case WM_MOUSEMOVE:						// appears only when I captured mouse-control
	return TRUE;								// Keep capturing to receive buttonup messages

	}

return FALSE;
}

BOOL WINAPI DllMain (HANDLE hModule, DWORD fdwReason, LPVOID lpvReserved)
{

	switch (fdwReason)
	{
	case DLL_PROCESS_ATTACH:
		break;

	case DLL_PROCESS_DETACH:
		break;
	}

	return TRUE;
}

void MakeCube (GLuint i, GLfloat cubesize, GLfloat * FrontColor)
{

glNewList(i, GL_COMPILE);
glDisable (GL_TEXTURE_2D);

if (FrontColor)glColor3fv(FrontColor);
glBegin(GL_QUADS);
glNormal3f(0.0,0.0,1.0);
glVertex3f(-cubesize,-cubesize,cubesize);
glVertex3f(cubesize,-cubesize,cubesize);
glVertex3f(cubesize,cubesize,cubesize);
glVertex3f(-cubesize,cubesize,cubesize);

glColor3f(0.6,0.6,0.6);
glNormal3f(0.0,0.0,-1.0);
glVertex3f(-cubesize,-cubesize,-cubesize);
glVertex3f(-cubesize,cubesize,-cubesize);
glVertex3f(cubesize,cubesize,-cubesize);
glVertex3f(cubesize,-cubesize,-cubesize);
glEnd();

glColor3f(0.6,0.6,0.6);
glBegin(GL_QUAD_STRIP);
glNormal3f(-1.0,0.0,0.0);
glVertex3f(-cubesize,-cubesize,-cubesize);
glVertex3f(-cubesize,-cubesize,cubesize);
glVertex3f(-cubesize,cubesize,-cubesize);
glVertex3f(-cubesize,cubesize,cubesize);

glNormal3f(0.0,1.0,0.0);
glVertex3f(cubesize,cubesize,-cubesize);
glVertex3f(cubesize,cubesize,cubesize);

glNormal3f(1.0,0.0,0.0);
glVertex3f(cubesize,-cubesize,-cubesize);
glVertex3f(cubesize,-cubesize,cubesize);

glNormal3f(0.0,-1.0,0.0);
glVertex3f(-cubesize,-cubesize,-cubesize);
glVertex3f(-cubesize,-cubesize,cubesize);
glEnd();

glEnable (GL_TEXTURE_2D);
glEndList();
}


void MakePhantomCube (GLuint i, GLfloat cubesize, GLfloat * FrontColor)
/******* Now create phantom list for color-picking  
the same as MakeCube, but you can draw a totally different shape or use less triangles
to speed it up
*********/
{
glNewList(i, GL_COMPILE);
glDisable (GL_TEXTURE_2D);

if (FrontColor)glColor3fv(FrontColor);
glBegin(GL_QUADS);
glNormal3f(0.0,0.0,1.0);
glVertex3f(-cubesize,-cubesize,cubesize);
glVertex3f(cubesize,-cubesize,cubesize);
glVertex3f(cubesize,cubesize,cubesize);
glVertex3f(-cubesize,cubesize,cubesize);

glColor3f(0.6,0.6,0.6);
glNormal3f(0.0,0.0,-1.0);
glVertex3f(-cubesize,-cubesize,-cubesize);
glVertex3f(-cubesize,cubesize,-cubesize);
glVertex3f(cubesize,cubesize,-cubesize);
glVertex3f(cubesize,-cubesize,-cubesize);
glEnd();

glColor3f(0.6,0.6,0.6);
glBegin(GL_QUAD_STRIP);
glNormal3f(-1.0,0.0,0.0);
glVertex3f(-cubesize,-cubesize,-cubesize);
glVertex3f(-cubesize,-cubesize,cubesize);
glVertex3f(-cubesize,cubesize,-cubesize);
glVertex3f(-cubesize,cubesize,cubesize);

glNormal3f(0.0,1.0,0.0);
glVertex3f(cubesize,cubesize,-cubesize);
glVertex3f(cubesize,cubesize,cubesize);

glNormal3f(1.0,0.0,0.0);
glVertex3f(cubesize,-cubesize,-cubesize);
glVertex3f(cubesize,-cubesize,cubesize);

glNormal3f(0.0,-1.0,0.0);
glVertex3f(-cubesize,-cubesize,-cubesize);
glVertex3f(-cubesize,-cubesize,cubesize);
glEnd();

glEnable (GL_TEXTURE_2D);
glEndList();
}

void MakeTextBox(GLuint i)
{
char * Text = "Plug-in Example";
HDC localhdc;
RECT tRect={0,0,0,0};
HBRUSH sBrush;
HBITMAP hbitmap;
char * dynbitmap;
BITMAPINFO bmi;
SIZE csize,lsize;
localhdc=CreateCompatibleDC(WhereIs3DTop->hDC);
SelectObject(localhdc,WhereIs3DTop->hFont);
SetBkColor(localhdc, RGB(200,200,200));
SetTextColor( localhdc, RGB(0,0,0));
GetTextExtentPoint32(localhdc,Text,lstrlen(Text),&lsize);
csize.cx=Getn(lsize.cx);                			// csize is size rounded-up to power of two,
csize.cy=Getn(lsize.cy);								// textures-size must be power of two
//for understanding, ignore, special version for TNT-chips which can
//only use square textures
	if (TNT)
		{
		if (csize.cy>csize.cx)csize.cx=csize.cy;
			else csize.cy=csize.cx;
		}
//
hbitmap=CreateCompatibleBitmap(WhereIs3DTop->hDC,csize.cx,csize.cy);
SelectObject(localhdc,hbitmap);
bmi.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
bmi.bmiHeader.biPlanes=1;
bmi.bmiHeader.biCompression=BI_RGB;
bmi.bmiHeader.biXPelsPerMeter=0;
bmi.bmiHeader.biYPelsPerMeter=0;
bmi.bmiHeader.biClrUsed=0;
bmi.bmiHeader.biClrImportant=0;
bmi.bmiHeader.biWidth=csize.cx;
bmi.bmiHeader.biHeight=csize.cy;
bmi.bmiHeader.biBitCount=24;
bmi.bmiHeader.biSizeImage=csize.cx*csize.cy*3;
tRect.right=csize.cx;
tRect.bottom=csize.cy;
sBrush = CreateSolidBrush(RGB(200,200,200));
FillRect(localhdc, &tRect,sBrush);					//Clear total bitmap for win95/98
tRect.right=lsize.cx;
tRect.bottom=lsize.cy;
DrawText( localhdc, Text, lstrlen(Text), &tRect, DT_WORDBREAK | DT_LEFT );
dynbitmap=(char *)GlobalAlloc(GMEM_FIXED,bmi.bmiHeader.biSizeImage);
GetDIBits(WhereIs3DTop->hDC,hbitmap,(csize.cy-lsize.cy),lsize.cy,dynbitmap,&bmi,DIB_RGB_COLORS);
CreateTextList(i, dynbitmap, lsize, csize);
GlobalFree(dynbitmap);
DeleteObject(hbitmap);
DeleteObject(sBrush);
DeleteDC(localhdc);
}

void CreateTextList(GLuint i, char * dynbitmap, SIZE lsize, SIZE csize)
{
GLfloat xoffset = -1.0, yoffset = 1.0, zoffset = 1.01;
GLfloat bottom = -textlength*(float)lsize.cy/(float)lsize.cx + yoffset;
GLfloat top = yoffset;

glBindTexture(GL_TEXTURE_2D,0);					//no texture-object

glNewList(i,GL_COMPILE);

//Although 3DTop uses texture-objects (with bind-texture) this example does not for simplicity-reasons
glTexImage2D(GL_TEXTURE_2D, 0, 1,
					csize.cx, csize.cy, 0,
					GL_BGR_EXT, GL_UNSIGNED_BYTE, dynbitmap);  //BGR_EXT
glColor3f( 1.0, 1.0, 1.0);
glNormal3f(0.0,0.0,1.0);

glBegin(GL_QUADS);
glTexCoord2f( 0.0, (float)lsize.cy / (float)csize.cy);
glVertex3f(0.0 + xoffset, top, zoffset);
glTexCoord2f( 0.0, 0.0);
glVertex3f(0.0 + xoffset, bottom, zoffset);
glTexCoord2f( (float)lsize.cx / (float)csize.cx, 0.0);
glVertex3f(  textlength + xoffset, bottom, zoffset);
glTexCoord2f( (float)lsize.cx / (float)csize.cx, (float)lsize.cy / (float)csize.cy);
glVertex3f( textlength + xoffset, top, zoffset);
glEnd();

glEndList();
}

GLuint Getn(GLuint n)
{GLuint i;
i=1;n--;
while(n){n>>=1;i<<=1;}
return (i);
}

